/*
 * Title:      Lockon Once Timer
 * Version:    1.1
 * Author:     Itou Hiroki
 * Copyright:  (c) 2003 Itou Hiroki
 * Time-stamp: <Dec 17 2003>
 *
 * Thanks to:  LOCK ON (c) 1998-2002 Tomoya Tokairin
 */

#include <windows.h>
#include <time.h>    /* time(), localtime() */
#include <stdio.h>   /* sprintf() */
#include "resources.h" /* ICON */

#define WND_WIDTH 212
#define WND_HEIGHT 132
#define BTN_WIDTH 12
#define BTN_HEIGHT 12
#define COURIERNEW24_HEIGHT 31
#define MSSANSSERIF12_HEIGHT 13
#define LOCKON_REC  1001  //1001 is IDC_BTREC in lkm15src/resource.h
#define LOCKON_STOP 1003  //1003 is IDC_BTSTOP in lkm15src/resource.h
#define STR_SHUTDOWN1 "shutdown Windows"
#define STR_SHUTDOWN2 "when waveflt2/lame/gogo lost"
#define STR_REC "REC"
#define STR_STOP "STOP"
enum {BTN_REC_H_UP, BTN_REC_H_DOWN, BTN_REC_M_UP, BTN_REC_M_DOWN, BTN_STOP_H_UP, BTN_STOP_H_DOWN, BTN_STOP_M_UP, BTN_STOP_M_DOWN, CHK_SHTDWN};


//global var
int rectime, stoptime;
HWND chk;
static char copyright[] = "Copyright (c) 2003 Itou Hiroki";

//func
int getTimeNow(void){
    time_t utime;
    struct tm *ttime;
    time(&utime);
    ttime = localtime(&utime);
    return ttime->tm_hour * 60 + ttime->tm_min;
}

int timeAdd(int srctime, int addmin){
    int n = srctime + addmin;
    return n % (24*60);
}

//hikizan(substruct)
int timeSub(int srctime, int submin){
    int n = srctime - submin;
    if(n < 0)
        n += 24*60;
    else if(n > 24*60)
        n -= 24*60;
    return n;
}

// 60 Ǥޤ (ʬ 0 ˤ)
int round60(int n){
    return n / 60 * 60;
    return n / 5 * 5;
}

// ret value
// 1 .. exist
// 0 .. not exist these window
int existLockonSubProcess(void){
    HWND hwf2;
    HWND hlame;
    HWND hgogo;

    hwf2 = FindWindow(NULL, "waveflt2");
    hlame = FindWindow(NULL, "lame");
    hgogo = FindWindow(NULL, "gogo");
    if(hwf2!=NULL || hlame!=NULL || hgogo!=NULL)
        return 1;
    return 0;
}


// ret value
// 1 .. killed
// 0 .. cannot kill the alert
int killAlert(HWND hlot){
    HWND hw;

    //ɥõ
    if((hw=FindWindow(NULL,"C-Media PCI Audio Driver Alert")) == NULL){
        return 0; //
    }

    //ɥ̤˽Ф
    if(SetForegroundWindow(hw) == FALSE){
        return 0; //
    }

    //space򲡤Υ
    keybd_event(VK_SPACE,0x45, 0,0);
    keybd_event(VK_SPACE,0x45, KEYEVENTF_KEYUP | 0,0);

    return 1; //
}


int pushLOCKON(int rec){
    HWND hw = FindWindow("LOCK ON", NULL);
    if(hw != NULL){
        SetForegroundWindow(hw); //ɬפʤ⤷ʤ̤ˤ

        if(rec == LOCKON_REC){
            PostMessage(hw, WM_COMMAND, LOCKON_REC, 0);
            return 1;
        }else if(rec == LOCKON_STOP){
            PostMessage(hw, WM_COMMAND, LOCKON_STOP, 0);
            return 1;
        }
    }
    // LOCK ON not found or error
    return 0;
}


void shutdownWindows(void){
    OSVERSIONINFO os;
    os.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
    GetVersionEx(&os);

    if(os.dwPlatformId==VER_PLATFORM_WIN32_WINDOWS){
        //Windows95/98/Me

        // LOGOFF 
        //ExitWindowsEx(EWX_POWEROFF | EWX_FORCE, 0);
        //ȲΤŸڤ
        ExitWindowsEx(EWX_SHUTDOWN | EWX_FORCE, 0);

    }else{
        // WindowsNT/2000/XP
        HANDLE       htoken;
        LUID         luid;    //Local Unique Identifer
        TOKEN_PRIVILEGES priv;

        //open access-token
        if(OpenProcessToken(GetCurrentProcess(),
                            TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY,
                            &htoken)) {
            if(LookupPrivilegeValue(NULL, SE_SHUTDOWN_NAME, &luid)) {
                //get luid of SE_SHUTDOWN_NAME-priv
                priv.PrivilegeCount = 1;
                priv.Privileges[0].Luid = luid;
                priv.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
                AdjustTokenPrivileges(htoken, FALSE, &priv,
                                      0, NULL, 0);
                if(GetLastError() == ERROR_SUCCESS)
                    ExitWindowsEx(EWX_POWEROFF | EWX_FORCE, 0);

            }
            // close opened token
            CloseHandle(htoken);
        }
    }
    return;
}        



LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp){
    HDC hdc;         //device context handle
    PAINTSTRUCT pa;  //re-draw the area hidden by other window
    static LOGFONT fc; //CourierNew logical font(font-information)
    static LOGFONT ft; //MS Sans Serif
    HFONT hfnt;        //font handle (GDI object)
    char s[6]; //ɽ˻
    int itime; //߻Ǽ
    RECT rct;  //ϰϤꤹȤ˻
    enum status { BEFORE_REC, AFTER_REC, BEFORE_STOP, AFTER_STOP, WAIT_SHUTDOWN };
    static int sta = BEFORE_REC;
    static int countdown = 5; //count to shutdown (5*2sec)
    static BOOL buttonChange = FALSE; //ѹܥ򲡤ľTRUEˤʤ
    static int killingalert = 0; //count to call killAlert()
    static unsigned char lamp = 0x00; //ɤlampΤ bit򤿤ƤƵϿ

    switch(msg){
    case WM_TIMER:
        //just after pushing button, no timer oparation is done
        //ѹܥ򲡤ľϡޡ¹Ԥʤ
        if(buttonChange == TRUE){
            buttonChange = FALSE;
            return 0;
        }
        switch (sta){
        case WAIT_SHUTDOWN:
            if(countdown <= 0){
                shutdownWindows();
                exit(0);
            }
            countdown--;
            break;
        case AFTER_STOP:
            //wavflt2/lame/gogo ʤ齪λʤ
            if(existLockonSubProcess()){
                return 0;
            }
            // ⤷ shutdown.. ΥܥååƤ Windows
            // åȥ󡢤ƤʤФΥץλ
            if(SendMessage(chk, BM_GETCHECK, 0,0)){
                sta = WAIT_SHUTDOWN; //if checked, exit win (10*2sec after)
                lamp |= (1<<WAIT_SHUTDOWN);
                rct.left = 8;
                rct.top = 73;
                rct.right = 18;
                rct.bottom = 73+10;
                InvalidateRect(hwnd, &rct, FALSE);
            }else{
                exit(0); //if not checked, exit self
            }
            break;
        case AFTER_REC:
            // killAlert ¹Ԥ
            // /ʤƤ5¹Ԥ STOPԤ˰ܹԤ
            if(killAlert(hwnd) == 1)
                sta = BEFORE_STOP; //BEFORE_STOP  lamp ˴طʤ
            killingalert++;
            if(killingalert > 5)
                sta = BEFORE_STOP;
            break;
        case BEFORE_STOP:
        case BEFORE_REC:
            itime = getTimeNow();
            if(sta==BEFORE_REC && itime == timeSub(rectime,1)){
                if(pushLOCKON(LOCKON_REC)){
                    // LOCKONɥ򸫤Ĥ REC ܥ󲡤Ȥ
                    // Ȥ ⡼ɰܹ
                    sta = AFTER_REC;
                    lamp |= (1<<AFTER_REC); //lamp  bit Ƥ
                    rct.left = 8;
                    rct.top = 4+14;
                    rct.right = 18;
                    rct.bottom = 28;
                    InvalidateRect(hwnd, &rct, FALSE);
                }
            }else if(itime == timeAdd(stoptime,1)){
                if(pushLOCKON(LOCKON_STOP)){
                    // LOCKONɥ򸫤Ĥ STOP ܥ󲡤Ȥ
                    // Ȥ shutdown ˰ܹԤ
                    sta = AFTER_STOP;
                    lamp |= (1<<AFTER_STOP);
                    rct.left = 8;
                    rct.top = 4+COURIERNEW24_HEIGHT+4+14;
                    rct.right = 18;
                    rct.bottom = 4+COURIERNEW24_HEIGHT+4+24;
                    InvalidateRect(hwnd, &rct, FALSE);
                    //åȥٹΰ̣̤ˤ
                    SetForegroundWindow(hwnd);
                }
            }
            break;
        default:
            break;
        }
        return 0;

    case WM_COMMAND:
        //push a button
        buttonChange = TRUE;

        switch(LOWORD(wp)){
        case BTN_REC_H_UP:
            rectime = timeAdd(rectime, 60);
            break;
        case BTN_REC_H_DOWN:
            rectime = timeSub(rectime, 60);
            break;
        case BTN_REC_M_UP:
            rectime = timeAdd(rectime, 5);
            break;
        case BTN_REC_M_DOWN:
            rectime = timeSub(rectime, 5);
            break;
        case BTN_STOP_H_UP:
            stoptime = timeAdd(stoptime, 60);
            break;
        case BTN_STOP_H_DOWN:
            stoptime = timeSub(stoptime, 60);
            break;
        case BTN_STOP_M_UP:
            stoptime = timeAdd(stoptime, 5);
            break;
        case BTN_STOP_M_DOWN:
            stoptime = timeSub(stoptime, 5);
            break;
        default:
            break;
        }
        // REC  STOP ο񤭴
        rct.left = 60;
        rct.top = 3;
        rct.right = 60+15*6;
        rct.bottom = 3+COURIERNEW24_HEIGHT;
        InvalidateRect(hwnd, &rct, FALSE);
        rct.left = 60;
        rct.top = 3+COURIERNEW24_HEIGHT+3;
        rct.right = 60+15*6;
        rct.bottom = 3+COURIERNEW24_HEIGHT+3+COURIERNEW24_HEIGHT;
        InvalidateRect(hwnd, &rct, FALSE);
        return 0;
    case WM_PAINT:
        //paint
        hdc = BeginPaint(hwnd, &pa);

        //show 'HOUR:MIN' (font:courier)
        hfnt = CreateFontIndirect(&fc);
        SelectObject(hdc,hfnt);
        sprintf(s, "%02d:%02d", rectime/60, rectime%60);
        TextOut(hdc,
                60,3,
                s,
                strlen(s)
                );
        sprintf(s, "%02d:%02d", stoptime/60, stoptime%60);
        TextOut(hdc,
                60,3+COURIERNEW24_HEIGHT+3, //3 is linegap
                s,
                strlen(s)
                );
        SetBkMode(hdc,TRANSPARENT);
        TextOut(hdc,
                163,3,
                "-1",
                strlen("-1"));
        TextOut(hdc,
                163,3+COURIERNEW24_HEIGHT+3,
                "+1",
                strlen("+1"));
        DeleteObject(hfnt);

        //show strings (font: MS Sans Serif)
        hfnt = CreateFontIndirect(&ft);
        SelectObject(hdc,hfnt);
        TextOut(hdc,
                8,4,
                STR_REC,
                strlen(STR_REC));
        TextOut(hdc,
                8,4+COURIERNEW24_HEIGHT+4,
                STR_STOP,
                strlen(STR_STOP));

        TextOut(hdc,
                57,4+COURIERNEW24_HEIGHT*2+4,
                STR_SHUTDOWN1,
                strlen(STR_SHUTDOWN1)
                );
        TextOut(hdc,
                57,4+COURIERNEW24_HEIGHT*2+4 + MSSANSSERIF12_HEIGHT,
                STR_SHUTDOWN2,
                strlen(STR_SHUTDOWN2)
                );

        //indicator 
        if(lamp & (1<<AFTER_REC)){
            HBRUSH br = CreateSolidBrush(RGB(0xff,0x00,0x00));
            SelectObject(hdc, br);
            Ellipse(hdc, 8,4+14, 18,28);
            SelectObject(hdc, GetStockObject(WHITE_BRUSH));
            DeleteObject(br);
        }
        if(lamp & (1<<AFTER_STOP)){
            HBRUSH br = CreateSolidBrush(RGB(0x00,0x00,0xff));
            SelectObject(hdc, br);
            Ellipse(hdc, 8,4+COURIERNEW24_HEIGHT+4+14, 18,4+COURIERNEW24_HEIGHT+4+24);
            SelectObject(hdc, GetStockObject(WHITE_BRUSH));
            DeleteObject(br);
        }
        if(lamp & (1<<WAIT_SHUTDOWN)){
            HBRUSH br = CreateSolidBrush(RGB(0xff,0xff,0x00));
            SelectObject(hdc, br);
            Ellipse(hdc, 8,73, 18,73+10);
            SelectObject(hdc, GetStockObject(WHITE_BRUSH));
            DeleteObject(br);
        }

        EndPaint(hwnd, &pa);
        return 0;
    case WM_DESTROY:
        PostQuitMessage(0);
        return(0);
    case WM_CREATE:
        //init var
        itime = getTimeNow();
        // 12:25 -> 13:00, 12:58 -> 14:00
        rectime = round60(timeAdd(itime,65));
        stoptime = round60(timeAdd(rectime, 60));

        // init timer
        SetTimer(hwnd, 1, 2*1000, NULL); //Send 'WM_TIMER' per 2sec

        //MS Sans Serif font
        ft.lfHeight = 12; //point
        ft.lfWidth = 0;
        ft.lfEscapement = 0;
        ft.lfOrientation = 0;
        ft.lfWeight = FW_REGULAR;
        ft.lfItalic = 0;
        ft.lfUnderline = 0;
        ft.lfStrikeOut = FALSE;
        ft.lfCharSet = ANSI_CHARSET;
        ft.lfOutPrecision = OUT_DEFAULT_PRECIS;
        ft.lfClipPrecision = CLIP_DEFAULT_PRECIS;
        ft.lfQuality = DEFAULT_QUALITY;
        ft.lfPitchAndFamily = VARIABLE_PITCH | FF_SWISS;
        strcpy(ft.lfFaceName,"MS Sans Serif");

        //courier new font
        fc.lfHeight = 32; //point
        fc.lfWidth = 0;
        fc.lfEscapement = 0;
        fc.lfOrientation = 0;
        fc.lfWeight = FW_BOLD;
        fc.lfItalic = 0;
        fc.lfUnderline = 0;
        fc.lfStrikeOut = FALSE;
        fc.lfCharSet = ANSI_CHARSET;
        fc.lfOutPrecision = OUT_DEFAULT_PRECIS;
        fc.lfClipPrecision = CLIP_DEFAULT_PRECIS;
        fc.lfQuality = DEFAULT_QUALITY;
        fc.lfPitchAndFamily = FIXED_PITCH | FF_MODERN;
        strcpy(fc.lfFaceName,"Courier New");

        return 0;
    }
    return DefWindowProc(hwnd, msg, wp, lp);
}


int WINAPI WinMain(HINSTANCE hinst, HINSTANCE hprevinst,
                   LPSTR argv, int argc){
    HWND hwnd;
    MSG msg;
    WNDCLASS wc;

    // WNDCLASS INFO
    wc.style = CS_VREDRAW | CS_HREDRAW;
    wc.lpfnWndProc = WndProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hinst;
    wc.hIcon = LoadIcon(hinst, MAKEINTRESOURCE(IDI_ICON));
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)COLOR_BACKGROUND;
    wc.lpszMenuName = NULL;
    wc.lpszClassName = "LOTIMER";

    // REGISTER WNDCLASS
    if(! RegisterClass(&wc)){
        return 0;
    }

    // GENERATE INSTANCE of WND
    hwnd = CreateWindow("LOTIMER", //lpClassName
                        "Lockon Once Timer", //lpWindowName
                        WS_OVERLAPPED | WS_CAPTION | WS_BORDER |
                        WS_SYSMENU | WS_VISIBLE,
                        CW_USEDEFAULT, CW_USEDEFAULT, //x,y
                        WND_WIDTH, WND_HEIGHT,        //w,h
                        NULL,                         //hWndParent
                        NULL,                         //hMenu
                        hinst,                        //hInstance
                        NULL                          //lpParam (MDI)
                        );

    //rokuon jikoku hennko
    CreateWindow("BUTTON",
                 "",
                 WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
                 43,4,
                 BTN_WIDTH, BTN_HEIGHT,
                 hwnd, (HMENU)BTN_REC_H_UP, hinst, NULL);
    CreateWindow("BUTTON",
                 "",
                 WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
                 43,18,
                 BTN_WIDTH, BTN_HEIGHT,
                 hwnd, (HMENU)BTN_REC_H_DOWN, hinst, NULL);
    CreateWindow("BUTTON",
                 "",
                 WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
                 148,4,
                 BTN_WIDTH, BTN_HEIGHT,
                 hwnd, (HMENU)BTN_REC_M_UP, hinst, NULL);
    CreateWindow("BUTTON",
                 "",
                 WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
                 148,18,
                 BTN_WIDTH, BTN_HEIGHT,
                 hwnd, (HMENU)BTN_REC_M_DOWN, hinst, NULL);

    //stop-jikoku hennko
    CreateWindow("BUTTON",
                 "",
                 WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
                 43,39,
                 BTN_WIDTH, BTN_HEIGHT,
                 hwnd, (HMENU)BTN_STOP_H_UP, hinst, NULL);
    CreateWindow("BUTTON",
                 "",
                 WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
                 43,53,
                 BTN_WIDTH, BTN_HEIGHT,
                 hwnd, (HMENU)BTN_STOP_H_DOWN, hinst, NULL);
    CreateWindow("BUTTON",
                 "",
                 WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
                 148,39,
                 BTN_WIDTH, BTN_HEIGHT,
                 hwnd, (HMENU)BTN_STOP_M_UP, hinst, NULL);
    CreateWindow("BUTTON",
                 "",
                 WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
                 148,53,
                 BTN_WIDTH, BTN_HEIGHT,
                 hwnd, (HMENU)BTN_STOP_M_DOWN, hinst, NULL);

    //checkbox
    chk = CreateWindow("BUTTON",
                       "",
                       WS_CHILD | WS_VISIBLE | BS_AUTOCHECKBOX,
                       40,73,
                       BTN_WIDTH, BTN_HEIGHT,
                       hwnd, (HMENU)CHK_SHTDWN, hinst, NULL);

    if(hwnd == NULL || chk == NULL)
        return 0;
    //pre-checked
    PostMessage(chk, BM_SETCHECK, BST_CHECKED, 0);

    // LOOP
    while(GetMessage(&msg, NULL, 0,0))
        DispatchMessage(&msg);

    // EXIT
    return msg.wParam; //exit value
}
//end of file
